// PgTweaks.cpp : implementation file
//

#include "stdafx.h"
#include "emule.h"
#include "PPgPhoenix.h"
#include "preferences.h"
#include "PreferencesDlg.h"
#include "HttpDownloadDlg.h"
#include "BandwidthControl.h"


#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

// CPPgPhoenix dialog

IMPLEMENT_DYNAMIC(CPPgPhoenix, CPreferencesPage) // [TPT] - SLUGFILLER: modelessDialogs
CPPgPhoenix::CPPgPhoenix()
	: CPreferencesPage(CPPgPhoenix::IDD) // [TPT] - SLUGFILLER: modelessDialogs
{	
	// [TPT] - Select process priority 
	switch (theApp.glob_prefs->GetWindowsVersion())
	{
		case _WINVER_98_:
		case _WINVER_95_:	
		case _WINVER_ME_:
			ExtraPrios = false;
			break;
		default: 
			ExtraPrios = true;
	}
	// [TPT] - Select process priority 
}

CPPgPhoenix::~CPPgPhoenix()
{
}

void CPPgPhoenix::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_PPG_MAELLA_TAB, m_tabCtr);
}

BEGIN_MESSAGE_MAP(CPPgPhoenix, CPreferencesPage) // [TPT] - SLUGFILLER: modelessDialogs
	// TAB control
	ON_NOTIFY(TCN_SELCHANGE, IDC_PPG_MAELLA_TAB, OnTabSelectionChange)
	ON_BN_CLICKED(IDC_PPG_PHOENIX_HIDEOS, OnSettingsChange) // [TPT] - SLUGFILLER: hideOS
	ON_BN_CLICKED(IDC_PPG_PHOENIX_SELECTIVESHARE, OnSettingsChange) // [TPT] - SLUGFILLER: hideOS
	ON_BN_CLICKED(IDC_PPG_PHOENIX_INFINITEQUEUE, OnSettingsChange) // [TPT] - SLUGFILLER: infiniteQueue
	ON_BN_CLICKED(IDC_PPG_PHOENIX_SHOWFILESYSTEMICON, OnSettingsChange)   // [TPT] - itsonlyme: displayOptions
	ON_BN_CLICKED(IDC_PPG_PHOENIX_SHOWLOCALRATING, OnSettingsChange)    	// [TPT] - itsonlyme: displayOptions
	ON_BN_CLICKED(IDC_PPG_PHOENIX_HIGHCONTRAST, OnSettingsChange)    	// [TPT] - MoNKi: -Support for High Contrast Mode-
	ON_BN_CLICKED(IDC_PPG_PHOENIX_QUICKSTART, OnQuickStartChange) // [TPT] - quick start   	
	// [TPT] - TBH: minimule
	ON_BN_CLICKED(IDC_PPG_PHOENIX_MINIMULE, OnSettingsChange)    	
	ON_BN_CLICKED(IDC_PPG_PHOENIX_MINIMULELIVES, OnSettingsChange)    	
	ON_EN_CHANGE(IDC_PPG_PHOENIX_MINIMULEUPDATE, OnSettingsChange)    	
	// [TPT] - TBH: minimule
	ON_WM_VSCROLL()
	ON_WM_HSCROLL()
END_MESSAGE_MAP()

// CPPgPhoenix message handlers

BOOL CPPgPhoenix::OnInitDialog()
{
	CPropertyPage::OnInitDialog();

	// Init the Tab control
	InitTab();

	// Create and Init all controls
	InitControl();

	// Set default tab
	m_currentTab = NONE;
	m_tabCtr.SetCurSel(0);
	SetTab(UPLOAD);

	// Load setting
	LoadSettings();
	Localize();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}

void CPPgPhoenix::LoadSettings()
{
	// [TPT] - SLUGFILLER: hideOS
	{
		CString buffer;
		buffer.Format(_T("%u"), theApp.glob_prefs->GetHideOvershares());
		m_iHideOS.SetWindowText(buffer);
	}	
	m_iSelectiveShare.SetCheck(theApp.glob_prefs->IsSelectiveShareEnabled());
	// [TPT] - SLUGFILLER: hideOS
	// [TPT] - itsonlyme: displayOptions START	
	m_iShowFileSystemIcon.SetCheck(theApp.glob_prefs->ShowFileSystemIcon());
	m_iShowLocalRating.SetCheck(theApp.glob_prefs->ShowLocalRating()); // [TPT] - SLUGFILLER: showComments
	// [TPT] - itsonlyme: displayOptions END
	
	// [TPT] - quick start
	m_iQuickStart.SetCheck(theApp.glob_prefs->GetQuickStart());
	{
		CString buffer;
		buffer.Format(_T("%u"), theApp.glob_prefs->GetQuickStartMaxConPerFive());
		m_iMaxConnPerFive.EnableWindow(m_iQuickStart.GetCheck() == BST_CHECKED);		
		m_iMaxConnPerFive.SetWindowText(buffer);
		m_iMaxConnPerFiveStatic.EnableWindow(m_iQuickStart.GetCheck() == BST_CHECKED);
		m_iMaxConn.EnableWindow(m_iQuickStart.GetCheck() == BST_CHECKED);
		buffer.Format(_T("%u"), theApp.glob_prefs->GetQuickStartMaxCon());
		m_iMaxConn.SetWindowText(buffer);
		m_iMaxConnStatic.EnableWindow(m_iQuickStart.GetCheck() == BST_CHECKED);
	}
	// [TPT] - quick start
	
	m_iClearCompleted.SetCheck(theApp.glob_prefs->GetClearCompleted()); // [TPT] - Clear completed
	
	// [TPT] - Select process priority 
	if (!ExtraPrios)
		switch (app_prefs->GetMainProcessPriority())
			{
				case ABOVE_NORMAL_PRIORITY_CLASS: m_selectPriorityProcess.SetPos(0); break;
				case BELOW_NORMAL_PRIORITY_CLASS: m_selectPriorityProcess.SetPos(2); break;
				default: m_selectPriorityProcess.SetPos(1);
			}
		else
			for (int i = 0; i < PROCESSPRIORITYNUMBER; i++)
			{
				if (PriorityClasses[i] == app_prefs->GetMainProcessPriority())
				{
					m_selectPriorityProcess.SetPos(i);
					break;
				}
			}			
	// [TPT] - Select process priority 
	
	// [TPT] - TBH: minimule
	m_iMiniMule.SetCheck(app_prefs->IsMiniMuleEnabled());
	m_iMiniMuleLives.SetCheck(app_prefs->GetMiniMuleLives());
	{
		CString buffer;
		buffer.Format(_T("%u"), app_prefs->GetMiniMuleUpdate());
		m_iMiniMuleUpdate.SetWindowText(buffer);
	}	
	m_MiniMuleTransparency.SetPos(app_prefs->GetMiniMuleTransparency());
	// [TPT] - TBH: minimule
	
	m_iInfiniteQueue.SetCheck(theApp.glob_prefs->IsInfiniteQueueEnabled());	// [TPT] - SLUGFILLER: infiniteQueue

	m_iHighContrast.SetCheck(theApp.glob_prefs->WindowsTextColorOnHighContrast()); // [TPT] - MoNKi: -Support for High Contrast Mode-
	
	// [TPT] - Credit System
	m_iCredits.SetPos(app_prefs->GetCreditSystem());
	
}

BOOL CPPgPhoenix::OnApply()
{	

	// [TPT] - SLUGFILLER: hideOS	
	{
		CString buffer;
		m_iHideOS.GetWindowText(buffer);
		int hideOS = _tstoi(buffer);
		if(hideOS > 5) hideOS = 5;
		if(hideOS < 0) hideOS = 0;
		app_prefs->prefs->hideOS = hideOS;		
	}	
	app_prefs->prefs->selectiveShare = m_iSelectiveShare.GetCheck();
	// [TPT] - SLUGFILLER: hideOS
	
	app_prefs->prefs->infiniteQueue = m_iInfiniteQueue.GetCheck();			// [TPT] - SLUGFILLER: infiniteQueue

	app_prefs->SetWindowsTextColorOnHighContrast(m_iHighContrast.GetCheck()); // [TPT] - MoNKi: -Support for High Contrast Mode-
	
	// [TPT] - itsonlyme: displayOptions START
	app_prefs->prefs->showFileSystemIcon = m_iShowFileSystemIcon.GetCheck();
	app_prefs->prefs->showLocalRating = m_iShowLocalRating.GetCheck();	// [TPT] - SLUGFILLER: showComments
	// [TPT] - itsonlyme: displayOptions END
	// [TPT] - itsonlyme: displayOptions
	theApp.emuledlg->sharedfileswnd.Invalidate(false);
	theApp.emuledlg->sharedfileswnd.UpdateWindow();
	theApp.emuledlg->transferwnd.Invalidate(false);
	theApp.emuledlg->transferwnd.UpdateWindow();
	// [TPT] - itsonlyme: displayOptions
	
	// [TPT] - quick start
	app_prefs->prefs->m_QuickStart = m_iQuickStart.GetCheck();
	if (m_iQuickStart.GetCheck() == BST_CHECKED)
	{
		CString buffer;
		m_iMaxConn.GetWindowText(buffer);
		int maxConn = _tstoi(buffer);
		app_prefs->SetQuickStartMaxCon(maxConn);
		m_iMaxConnPerFive.GetWindowText(buffer);
		maxConn = _tstoi(buffer);
		app_prefs->SetQuickStartMaxConPerFive(maxConn);
	}
	// [TPT] - quick start

	app_prefs->prefs->m_ClearCompleted = m_iClearCompleted.GetCheck(); // [TPT] - Clear completed

	// [TPT] - Select process priority 
	if (!ExtraPrios)
		switch (m_selectPriorityProcess.GetPos())
		{
			case 0: app_prefs->m_MainProcessPriority = HIGH_PRIORITY_CLASS; break;			
			case 2: app_prefs->m_MainProcessPriority = IDLE_PRIORITY_CLASS; break;
			default: app_prefs->m_MainProcessPriority = NORMAL_PRIORITY_CLASS;
		}
	else
		app_prefs->m_MainProcessPriority = PriorityClasses[m_selectPriorityProcess.GetPos()];	
	// [TPT] - Select process priority 
	
	
	// [TPT] - TBH: minimule
	app_prefs->SetMiniMuleEnabled(m_iMiniMule.GetCheck());
	app_prefs->SetMiniMuleLives(m_iMiniMuleLives.GetCheck());	
	{
		CString buffer;
		m_iMiniMuleUpdate.GetWindowText(buffer);
		int update = _tstoi(buffer);		
		if(update < 0) update = 0;
		app_prefs->SetMiniMuleUpdate(update);		
	}	
	app_prefs->SetMiniMuleTransparency(m_MiniMuleTransparency.GetPos());
	// [TPT] - TBH: minimule
	// [TPT] - Credit System
	app_prefs->SetCreditSystem(m_iCredits.GetPos());
	
	
	// Refresh Setting
	LoadSettings();
	SetModified(FALSE);	

	return CPropertyPage::OnApply();
}

void CPPgPhoenix::Localize(void)
{	
	if(m_hWnd)
	{
		// Create an icon list for the tab control
		m_ImageList.DeleteImageList();
		m_ImageList.Create(16,16,theApp.m_iDfltImageListColorFlags|ILC_MASK,0,1);
		m_ImageList.SetBkColor(CLR_NONE);
		m_ImageList.Add(CTempIconLoader("upload"));
		m_ImageList.Add(CTempIconLoader("trayconnected"));
		m_ImageList.Add(CTempIconLoader("myinfo"));
		m_ImageList.Add(CTempIconLoader("clientcompatible"));

		CString Buffer;
		SetWindowText(_T("Phoenix's"));		

		int row = m_tabCtr.GetRowCount();
		InitTab(); // To update string, could be improved
		if(row != 0 && row != m_tabCtr.GetRowCount()){
			// Shift all windows object
			// .. to do
		}
	
		// [TPT] - SLUGFILLER: hideOS
		m_iHideOSStatic.SetWindowText(GetResString(IDS_HIDEOVERSHARES));
		m_iSelectiveShare.SetWindowText(GetResString(IDS_SELECTIVESHARE));
		// [TPT] - SLUGFILLER: hideOS
		m_iInfiniteQueue.SetWindowText(GetResString(IDS_INFINITEQUEUE));	// [TPT] - SLUGFILLER: infiniteQueue
		// [TPT] - itsonlyme: displayOptions START	
		m_iShowFileSystemIcon.SetWindowText(GetResString(IDS_SHOWFILESYSICON));
		m_iShowLocalRating.SetWindowText(GetResString(IDS_SHOWLOCALRATING)); // [TPT] - SLUGFILLER: showComments
		// [TPT] - itsonlyme: displayOptions END
		
		m_iHighContrast.SetWindowText(GetResString(IDS_HIGH_CONTRAST)); // [TPT] - MoNKi: -Support for High Contrast Mode-

		// [TPT] - quick start		
		m_iQuickStart.SetWindowText(GetResString(IDS_QUICK_START)); 
		m_iMaxConnStatic.SetWindowText(GetResString(IDS_QUICK_START_MAX_CONN));
		m_iMaxConnPerFiveStatic.SetWindowText(GetResString(IDS_QUICK_START_MAX_CONN_PER_FIVE));
		// [TPT] - quick start

		m_iClearCompleted.SetWindowText(GetResString(IDS_CLEAR_COMPLETED)); // [TPT] - Clear completed
		
		// [TPT] - Select process priority 
		m_PriorityGroupBox.SetWindowText(GetResString(IDS_PRIO_GROUP));
		m_HighPriority.SetWindowText(GetResString(IDS_PRIO_HIGH));		
		m_NormalPriority.SetWindowText(GetResString(IDS_PRIO_NORMAL));		
		m_IdlePriority.SetWindowText(GetResString(IDS_PRIO_IDLE));
		if (ExtraPrios)
		{
			m_RealTimePriority.SetWindowText(GetResString(IDS_PRIO_TIME_CRITICAL));
			m_AboveNormalPriority.SetWindowText(GetResString(IDS_PRIO_ABOVE_NORMAL));
			m_BelowNormalPriority.SetWindowText(GetResString(IDS_PRIO_BELOW_NORMAL));
		}
		// [TPT] - Select process priority 
			
		// [TPT] - The Black Hand: MiniMule		[TPT] - TBH: minimule
		m_MiniMuleGroupBox.SetWindowText(GetResString(IDS_MINIMULE));
		m_iMiniMule.SetWindowText(GetResString(IDS_SHOWMINIMULE));		
		m_iMiniMuleLives.SetWindowText(GetResString(IDS_MINIMULELIVES));
		m_iMiniMuleUpdateStatic.SetWindowText(GetResString(IDS_MINIMULEUPDATE));
		{   // Transparency			
			CString text;
			text.Format(GetResString(IDS_MINIMULETRANS), m_MiniMuleTransparency.GetPos());
			m_MiniMuleTransparencyStatic.SetWindowText(text);
		}
		m_MiniMuleTransparencyMinimum.SetWindowText(GetResString(IDS_MINIMUM));
		m_MiniMuleTransparencyMaximum.SetWindowText(GetResString(IDS_MAXIMUM));
		// [TPT] - TBH: minimule

		// [TPT] - Credit System
		m_iCreditsGroupBox.SetWindowText(GetResString(IDS_CREDITS_SEL)); // [TPT] - CreditSystem
		m_iCreditsPawcioStatic.SetWindowText(GetResString(IDS_CREDITS_PAWCIO));
		m_iCreditsLovelaceStatic.SetWindowText(GetResString(IDS_CREDITS_LOVELACE));
		m_iCreditsOfficialStatic.SetWindowText(GetResString(IDS_CREDITS_OFICIAL));
		m_iCreditsNoneStatic.SetWindowText(GetResString(IDS_CREDITS_NONE));
		// [TPT] - Credit System
	}
}

void CPPgPhoenix::InitTab(){
	// Clear all to be sure
	m_tabCtr.DeleteAllItems();
	
	// Change style
	// Remark: It seems that the multi-row can not be activated with the properties
	m_tabCtr.ModifyStyle(0, TCS_MULTILINE);

	// Add all items with icon (connection, tweak, etc...)
	m_tabCtr.SetImageList(&m_ImageList);
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, UPLOAD, GetResString(IDS_TW_UPLOADS), 0, (LPARAM)UPLOAD); 	
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, MISCELLANEOUS, GetResString(IDS_PW_MISC), 1, (LPARAM)MISCELLANEOUS); 		
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, VISUALIZATION, GetResString(IDS_PREF_VISUALIZATION), 2, (LPARAM)VISUALIZATION); 	
	m_tabCtr.InsertItem(TCIF_TEXT | TCIF_IMAGE | TCIF_PARAM, MINIMULE, GetResString(IDS_MINIMULE), 3, (LPARAM)MINIMULE); 		
}

void CPPgPhoenix::InitControl(){
	// Remark: don't use the dialog editor => avoid to merge rc

	// Retrieve the bottom of the tab's header
	RECT rect1;
	RECT rect2;
	m_tabCtr.GetWindowRect(&rect1);
	ScreenToClient(&rect1);
	m_tabCtr.GetItemRect(m_tabCtr.GetItemCount() - 1 , &rect2);
	const int top = rect1.top + (rect2.bottom - rect2.top + 1) * m_tabCtr.GetRowCount() + 10;
	const int right = rect1.left + 10;
	const int bottom = rect1.bottom;
	
	//-- UPLOAD
	// [TPT] - SLUGFILLER: hideOS
	m_iHideOS.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
						WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
						ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
						CRect(right, top+20, right+20, top+20+20), this,  IDC_PPG_PHOENIX_HIDEOS);
	m_iHideOS.SetFont(GetFont());
	m_iHideOS.SetLimitText(1);
	m_iHideOSStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+25, top+20, right+25+260, top+20+25), this, IDC_PPG_PHOENIX_HIDEOS_STATIC);
	m_iHideOSStatic.SetFont(GetFont());

	m_iSelectiveShare.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+20+30, right+300, top+20+30+20), this, IDC_PPG_PHOENIX_SELECTIVESHARE);
	m_iSelectiveShare.SetFont(GetFont());	
	// [TPT] - SLUGFILLER: hideOS
	
	// [TPT] - SLUGFILLER: infiniteQueue
	m_iInfiniteQueue.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+20+60, right+300, top+20+60+20), this, IDC_PPG_PHOENIX_INFINITEQUEUE);
	m_iInfiniteQueue.SetFont(GetFont());	
	// [TPT] - SLUGFILLER: infiniteQueue
	
	// [TPT] - itsonlyme: displayOptions START	
	m_iShowFileSystemIcon.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+20, right+300, top+20+20), this, IDC_PPG_PHOENIX_SHOWFILESYSTEMICON);
	m_iShowFileSystemIcon.SetFont(GetFont());	
	// [TPT] - SLUGFILLER: showComments
	m_iShowLocalRating.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+20+30, right+300, top+30+40), this, IDC_PPG_PHOENIX_SHOWLOCALRATING);
	m_iShowLocalRating.SetFont(GetFont());
	// [TPT] - itsonlyme: displayOptions END

	
	// [TPT] - MoNKi: -Support for High Contrast Mode-
	m_iHighContrast.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+80, right+300, top+80+20), this, IDC_PPG_PHOENIX_HIGHCONTRAST);
	m_iHighContrast.SetFont(GetFont());	
	// [TPT] - MoNKi: -Support for High Contrast Mode-

	// [TPT] - Clear completed
	m_iClearCompleted.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+110, right+300, top+110+20), this, IDC_PPG_PHOENIX_CLEAR_COMPLETED);
	m_iClearCompleted.SetFont(GetFont());	
	// [TPT] - Clear completed
	
	// [TPT] - Select process priority 
	m_PriorityGroupBox.CreateEx(0, _T("BUTTON"), "", 
							   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							   BS_GROUPBOX,
							   CRect(right, top+20, right+150, top+20+160), this, IDC_PPG_PHOENIX_PRIORITY_GROUP_BOX);
	m_PriorityGroupBox.SetFont(GetFont());

	m_selectPriorityProcess.CreateEx(WS_EX_STATICEDGE,
							  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							  TBS_TOOLTIPS | TBS_BOTH | TBS_VERT | TBS_NOTICKS,
							  CRect(right+10, top+20+30, right+10+20, top+20+30+120), this, IDC_PPG_PHOENIX_PROCESSPRIORITY);
	m_selectPriorityProcess.SetFont(GetFont());
	m_selectPriorityProcess.SetRange(0, 5);	
	if (ExtraPrios)
	{
		m_selectPriorityProcess.SetRange(0, 5);
		m_RealTimePriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30, right+10+25+105, top+20+30+15), this, IDC_PPG_PHOENIX_REALTIMEPRIORITY);
		m_RealTimePriority.SetFont(GetFont());
		m_HighPriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30+20, right+10+25+105, top+20+30+20+15), this, IDC_PPG_PHOENIX_HIGHPRIORITY);
		m_HighPriority.SetFont(GetFont());
		m_AboveNormalPriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30+40, right+10+25+105, top+20+30+40+15), this, IDC_PPG_PHOENIX_ABOVENORMALPRIORITY);
		m_AboveNormalPriority.SetFont(GetFont());
		m_NormalPriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30+60, right+10+25+105, top+20+30+60+15), this, IDC_PPG_PHOENIX_NORMALPRIORITY);
		m_NormalPriority.SetFont(GetFont());
		m_BelowNormalPriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30+80, right+10+25+105, top+20+30+80+15), this, IDC_PPG_PHOENIX_BELOWNORMALPRIORITY);
		m_BelowNormalPriority.SetFont(GetFont());
		m_IdlePriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30+100, right+10+25+105, top+20+30+100+15), this, IDC_PPG_PHOENIX_IDLEPRIORITY);
		m_IdlePriority.SetFont(GetFont());
	}
	else
	{
		m_selectPriorityProcess.SetRange(0, 2);		
		m_HighPriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30, right+10+25+105, top+20+30+15), this, IDC_PPG_PHOENIX_HIGHPRIORITY);
		m_HighPriority.SetFont(GetFont());		
		m_NormalPriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30+50, right+10+25+105, top+20+30+50+15), this, IDC_PPG_PHOENIX_NORMALPRIORITY);
		m_NormalPriority.SetFont(GetFont());		
		m_IdlePriority.CreateEx(0, _T("STATIC"), "", 
								WS_CHILD /*| WS_VISIBLE*/, 
								CRect(right+10+25, top+20+30+100, right+10+25+105, top+20+30+100+15), this, IDC_PPG_PHOENIX_IDLEPRIORITY);
		m_IdlePriority.SetFont(GetFont());
	}
	// [TPT] - Select process priority 

	// [TPT] - Credit System
	m_iCreditsGroupBox.CreateEx(0, _T("BUTTON"), "", 
							   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							   BS_GROUPBOX,
							   CRect(right+160, top+20, right+310, top+20+150), this, IDC_PPG_PHOENIX_CREDITS_GROUP_BOX);
	m_iCreditsGroupBox.SetFont(GetFont());		

	m_iCredits.CreateEx(WS_EX_STATICEDGE,
							  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							  TBS_TOOLTIPS | TBS_BOTH | TBS_VERT | TBS_NOTICKS,
							  CRect(right+160+10, top+20+30, right+160+30, top+20+30+110), this, IDC_PPG_PHOENIX_CREDITS);
	m_iCredits.SetFont(GetFont());
	m_iCredits.SetRange(0, 3);	

	m_iCreditsLovelaceStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+160+10+40, top+20+30, right+160+10+130, top+20+30+20), this, IDC_PPG_PHOENIX_LOVELACE_CREDITS_STATIC);
	m_iCreditsLovelaceStatic.SetFont(GetFont());	
	
	m_iCreditsPawcioStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+160+10+40, top+20+30+30, right+160+10+130, top+20+30+30+20), this, IDC_PPG_PHOENIX_PAWCIO_CREDITS_STATIC);
	m_iCreditsPawcioStatic.SetFont(GetFont());		
		
	m_iCreditsOfficialStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+160+10+40, top+20+30+60, right+160+10+130, top+20+30+60+20), this, IDC_PPG_PHOENIX_OFFICIAL_CREDITS_STATIC);
	m_iCreditsOfficialStatic.SetFont(GetFont());	

	m_iCreditsNoneStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+160+10+40, top+20+30+90, right+160+10+130, top+20+30+90+20), this, IDC_PPG_PHOENIX_NONE_CREDITS_STATIC);
	m_iCreditsNoneStatic.SetFont(GetFont());	
	// [TPT] - Credit System

	// [TPT] - quick start
	m_iQuickStart.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right, top+190, right+300, top+190+20), this, IDC_PPG_PHOENIX_QUICKSTART);
	m_iQuickStart.SetFont(GetFont());

	m_iMaxConnPerFive.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
						WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
						ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
						CRect(right+10, top+220, right+50, top+220+20), this,  IDC_PPG_PHOENIX_QUICKSTART_CONN_PER_FIVE);
	m_iMaxConnPerFive.SetFont(GetFont());
	m_iMaxConnPerFive.SetLimitText(4);
	m_iMaxConnPerFiveStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+55, top+222, right+55+230, top+222+20), this, IDC_PPG_PHOENIX_QUICKSTART_CONN_PER_FIVE_STATIC);
	m_iMaxConnPerFiveStatic.SetFont(GetFont());

	m_iMaxConn.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
						WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
						ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
						CRect(right+10, top+250, right+50, top+250+20), this,  IDC_PPG_PHOENIX_QUICKSTART_CONN);
	m_iMaxConn.SetFont(GetFont());
	m_iMaxConn.SetLimitText(4);
	m_iMaxConnStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+55, top+252, right+55+230, top+252+20), this, IDC_PPG_PHOENIX_QUICKSTART_CONN_STATIC);
	m_iMaxConnStatic.SetFont(GetFont());
	// [TPT] - quick start

	//-- Minimule

	// [TPT] - TBH: minimule
	m_MiniMuleGroupBox.CreateEx(0, _T("BUTTON"), "", 
							   WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
							   BS_GROUPBOX,
							   CRect(right, top+20, right+300, top+20+190), this, IDC_PPG_PHOENIX_MINIMULE_GROUP_BOX);
	m_MiniMuleGroupBox.SetFont(GetFont());

	m_iMiniMule.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+15, right+10+280, top+20+15+20), this, IDC_PPG_PHOENIX_MINIMULE);
	m_iMiniMule.SetFont(GetFont());	
	
	m_iMiniMuleLives.CreateEx(0, _T("BUTTON"), "", 
									 WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP |
									 BS_AUTOCHECKBOX, 
									 CRect(right+10, top+20+45, right+10+280, top+20+45+20), this, IDC_PPG_PHOENIX_MINIMULELIVES);
	m_iMiniMuleLives.SetFont(GetFont());	
	
	m_iMiniMuleUpdate.CreateEx(WS_EX_CLIENTEDGE, _T("EDIT"), "", 
						WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
						ES_RIGHT | ES_AUTOHSCROLL | ES_NUMBER, 
						CRect(right+10, top+20+75, right+10+20, top+20+75+20), this,  IDC_PPG_PHOENIX_MINIMULEUPDATE);;
	m_iMiniMuleUpdate.SetFont(GetFont());
	m_iMiniMuleUpdate.SetLimitText(4);
	
	m_iMiniMuleUpdateStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+10+25, top+20+75, right+10+25+255, top+20+75+20), this, IDC_PPG_PHOENIX_MINIMULEUPDATE_STATIC);
	m_iMiniMuleUpdateStatic.SetFont(GetFont());	

	m_MiniMuleTransparency.CreateEx(WS_EX_STATICEDGE,
							  WS_CHILD /*| WS_VISIBLE*/ | WS_TABSTOP | WS_BORDER |
							  TBS_TOOLTIPS | TBS_BOTH | TBS_HORZ | TBS_NOTICKS,
							  CRect(right+10+15, top+20+140, right+10+15+255, top+20+140+20), this, IDC_PPG_PHOENIX_MINIMULE_TRANSPARENCY);
	m_MiniMuleTransparency.SetFont(GetFont());
	m_MiniMuleTransparency.SetRange(0, 255);	
	
	m_MiniMuleTransparencyStatic.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+10, top+20+115, right+10+120, top+20+115+20), this, IDC_PPG_PHOENIX_MINIMULE_TRANSP_STATIC);
	m_MiniMuleTransparencyStatic.SetFont(GetFont());	

	m_MiniMuleTransparencyMinimum.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+10+15, top+20+165, right+10+15+55, top+20+165+20), this, IDC_PPG_PHOENIX_MINIMULE_TRANSP_MINIMUM);
	m_MiniMuleTransparencyMinimum.SetFont(GetFont());	

	m_MiniMuleTransparencyMaximum.CreateEx(0, _T("STATIC"), "", 
							WS_CHILD /*| WS_VISIBLE*/, 
							CRect(right+10+15+210, top+20+165, right+10+15+265, top+20+165+20), this, IDC_PPG_PHOENIX_MINIMULE_TRANSP_MAXIMUM);
	m_MiniMuleTransparencyMaximum.SetFont(GetFont());	
	// [TPT] - TBH: minimule


}

void CPPgPhoenix::OnTabSelectionChange(NMHDR *pNMHDR, LRESULT *pResult)
{
	// Retrieve tab to display
	TCITEM tabCtrlItem; 
	tabCtrlItem.mask = TCIF_PARAM;
	if(m_tabCtr.GetItem(m_tabCtr.GetCurSel(), &tabCtrlItem) == TRUE){
		SetTab(static_cast<eTab>(tabCtrlItem.lParam));
	}

	*pResult = 0;
}

void CPPgPhoenix::OnVScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);	

	CPropertyPage::OnVScroll(nSBCode, nPos, pScrollBar);
}

void CPPgPhoenix::OnHScroll(UINT nSBCode, UINT nPos, CScrollBar* pScrollBar) 
{
	SetModified(TRUE);
	
	CSliderCtrl* slider =(CSliderCtrl*)pScrollBar;
	int position = slider->GetPos();
	// [TPT] - TBH: minimule
	if(slider == &m_MiniMuleTransparency){
		CString text;
		text.Format(GetResString(IDS_MINIMULETRANS), position);
		m_MiniMuleTransparencyStatic.SetWindowText(text);
	}
	// [TPT] - TBH: minimule

	CPropertyPage::OnHScroll(nSBCode, nPos, pScrollBar);
}

void CPPgPhoenix::SetTab(eTab tab){
	if(m_currentTab != tab){
		// Hide all control
		switch(m_currentTab){
			case UPLOAD:
				// [TPT] - SLUGFILLER: hideOS
				m_iHideOS.ShowWindow(SW_HIDE);
				m_iHideOS.EnableWindow(FALSE);		
				m_iHideOSStatic.ShowWindow(SW_HIDE);
				m_iHideOSStatic.EnableWindow(FALSE);
				m_iSelectiveShare.ShowWindow(SW_HIDE);
				m_iSelectiveShare.EnableWindow(FALSE);			
				// [TPT] - SLUGFILLER: infiniteQueue
				m_iInfiniteQueue.ShowWindow(SW_HIDE);
				m_iInfiniteQueue.EnableWindow(FALSE);	
				break;		
			case MISCELLANEOUS:
				// [TPT] - quick start
				m_iQuickStart.ShowWindow(SW_HIDE);
				m_iQuickStart.EnableWindow(FALSE);
				m_iMaxConn.ShowWindow(SW_HIDE);
				m_iMaxConn.EnableWindow(FALSE);
				m_iMaxConnStatic.ShowWindow(SW_HIDE);
				m_iMaxConnStatic.EnableWindow(FALSE);
				m_iMaxConnPerFive.ShowWindow(SW_HIDE);
				m_iMaxConnPerFive.EnableWindow(FALSE);
				m_iMaxConnPerFiveStatic.ShowWindow(SW_HIDE);
				m_iMaxConnPerFiveStatic.EnableWindow(FALSE);
				// [TPT] - Select process priority 
				m_selectPriorityProcess.ShowWindow(SW_HIDE);
				m_selectPriorityProcess.EnableWindow(FALSE);				
				m_PriorityGroupBox.ShowWindow(SW_HIDE);
				m_PriorityGroupBox.EnableWindow(FALSE);				
				m_HighPriority.ShowWindow(SW_HIDE);
				m_HighPriority.EnableWindow(FALSE);				
				m_NormalPriority.ShowWindow(SW_HIDE);
				m_NormalPriority.EnableWindow(FALSE);				
				m_IdlePriority.ShowWindow(SW_HIDE);
				m_IdlePriority.EnableWindow(FALSE);
				if (ExtraPrios)
				{
					m_RealTimePriority.ShowWindow(SW_HIDE);
					m_RealTimePriority.EnableWindow(FALSE);
					m_AboveNormalPriority.ShowWindow(SW_HIDE);
					m_AboveNormalPriority.EnableWindow(FALSE);
					m_BelowNormalPriority.ShowWindow(SW_HIDE);
					m_BelowNormalPriority.EnableWindow(FALSE);
				}		
				// [TPT] - Credit System
				m_iCredits.ShowWindow(SW_HIDE);
				m_iCredits.EnableWindow(FALSE);	
				m_iCreditsGroupBox.ShowWindow(SW_HIDE);
				m_iCreditsGroupBox.EnableWindow(FALSE);	
				m_iCreditsPawcioStatic.ShowWindow(SW_HIDE);
				m_iCreditsPawcioStatic.EnableWindow(FALSE);	
				m_iCreditsLovelaceStatic.ShowWindow(SW_HIDE);
				m_iCreditsLovelaceStatic.EnableWindow(FALSE);	
				m_iCreditsOfficialStatic.ShowWindow(SW_HIDE);
				m_iCreditsOfficialStatic.EnableWindow(FALSE);	
				m_iCreditsNoneStatic.ShowWindow(SW_HIDE);
				m_iCreditsNoneStatic.EnableWindow(FALSE);	
				// [TPT] - Credit System
				break;
			case CATEGORIES:
					
				break;
			case VISUALIZATION:
				// [TPT] - itsonlyme: displayOptions
				m_iShowFileSystemIcon.ShowWindow(SW_HIDE);
				m_iShowFileSystemIcon.EnableWindow(FALSE);								
				m_iShowLocalRating.ShowWindow(SW_HIDE);
				m_iShowLocalRating.EnableWindow(FALSE);
				// [TPT] - MoNKi: -Support for High Contrast Mode-
				m_iHighContrast.ShowWindow(SW_HIDE);
				m_iHighContrast.EnableWindow(FALSE);
				// [TPT] - Clear completed
				m_iClearCompleted.ShowWindow(SW_HIDE);
				m_iClearCompleted.EnableWindow(FALSE);
								
				break;
			case MINIMULE:
				m_MiniMuleGroupBox.ShowWindow(SW_HIDE);
				m_MiniMuleGroupBox.EnableWindow(FALSE);	
				m_iMiniMule.ShowWindow(SW_HIDE);
				m_iMiniMule.EnableWindow(FALSE);	
				m_iMiniMuleLives.ShowWindow(SW_HIDE);
				m_iMiniMuleLives.EnableWindow(FALSE);	
				m_iMiniMuleUpdate.ShowWindow(SW_HIDE);
				m_iMiniMuleUpdate.EnableWindow(FALSE);	
				m_iMiniMuleUpdateStatic.ShowWindow(SW_HIDE);
				m_iMiniMuleUpdateStatic.EnableWindow(FALSE);	
				m_MiniMuleTransparency.ShowWindow(SW_HIDE);
				m_MiniMuleTransparency.EnableWindow(FALSE);	
				m_MiniMuleTransparencyStatic.ShowWindow(SW_HIDE);
				m_MiniMuleTransparencyStatic.EnableWindow(FALSE);	
				m_MiniMuleTransparencyMinimum.ShowWindow(SW_HIDE);
				m_MiniMuleTransparencyMinimum.EnableWindow(FALSE);	
				m_MiniMuleTransparencyMaximum.ShowWindow(SW_HIDE);
				m_MiniMuleTransparencyMaximum.EnableWindow(FALSE);	
				break;
		}

		// Show new controls
		m_currentTab = tab;
		switch(m_currentTab){
			case UPLOAD:
				// [TPT] - SLUGFILLER: hideOS
				m_iHideOS.ShowWindow(SW_SHOW);
				m_iHideOS.EnableWindow(TRUE);
				m_iHideOSStatic.ShowWindow(SW_SHOW);
				m_iHideOSStatic.EnableWindow(TRUE);				
				m_iSelectiveShare.ShowWindow(SW_SHOW);
				m_iSelectiveShare.EnableWindow(TRUE);																					
				// [TPT] - SLUGFILLER: infiniteQueue
				m_iInfiniteQueue.ShowWindow(SW_SHOW);
				m_iInfiniteQueue.EnableWindow(TRUE);	
				break;			
			case MISCELLANEOUS:
				// [TPT] - quick start
				m_iQuickStart.ShowWindow(SW_SHOW);
				m_iQuickStart.EnableWindow(TRUE);
				m_iMaxConn.ShowWindow(SW_SHOW);				
				m_iMaxConnStatic.ShowWindow(SW_SHOW);
				m_iMaxConnPerFive.ShowWindow(SW_SHOW);
				m_iMaxConnPerFiveStatic.ShowWindow(SW_SHOW);
				if (app_prefs->prefs->m_QuickStart == true)
				{
					m_iMaxConn.EnableWindow(TRUE);
					m_iMaxConnStatic.EnableWindow(TRUE);				
					m_iMaxConnPerFive.EnableWindow(TRUE);				
					m_iMaxConnPerFiveStatic.EnableWindow(TRUE);
				}
				// [TPT] - Select process priority 
			    m_selectPriorityProcess.ShowWindow(SW_SHOW);
				m_selectPriorityProcess.EnableWindow(TRUE);
				m_PriorityGroupBox.ShowWindow(SW_SHOW);
				m_PriorityGroupBox.EnableWindow(TRUE);
				m_HighPriority.ShowWindow(SW_SHOW);
				m_HighPriority.EnableWindow(TRUE);				
				m_NormalPriority.ShowWindow(SW_SHOW);
				m_NormalPriority.EnableWindow(TRUE);				
				m_IdlePriority.ShowWindow(SW_SHOW);
				m_IdlePriority.EnableWindow(TRUE);
				if (ExtraPrios)
				{
					m_RealTimePriority.ShowWindow(SW_SHOW);
					m_RealTimePriority.EnableWindow(TRUE);
					m_AboveNormalPriority.ShowWindow(SW_SHOW);
					m_AboveNormalPriority.EnableWindow(TRUE);
					m_BelowNormalPriority.ShowWindow(SW_SHOW);
					m_BelowNormalPriority.EnableWindow(TRUE);
				} 
			   // [TPT] - Credit System
				m_iCredits.ShowWindow(SW_SHOW);
				m_iCredits.EnableWindow(TRUE);	
				m_iCreditsGroupBox.ShowWindow(SW_SHOW);
				m_iCreditsGroupBox.EnableWindow(TRUE);	
				m_iCreditsPawcioStatic.ShowWindow(SW_SHOW);
				m_iCreditsPawcioStatic.EnableWindow(TRUE);	
				m_iCreditsLovelaceStatic.ShowWindow(SW_SHOW);
				m_iCreditsLovelaceStatic.EnableWindow(TRUE);	
				m_iCreditsOfficialStatic.ShowWindow(SW_SHOW);
				m_iCreditsOfficialStatic.EnableWindow(TRUE);	
				m_iCreditsNoneStatic.ShowWindow(SW_SHOW);
				m_iCreditsNoneStatic.EnableWindow(TRUE);	
				// [TPT] - Credit System
				break;
			case CATEGORIES:
					
				break;
			case VISUALIZATION:
				// [TPT] - itsonlyme: displayOptions
				m_iShowFileSystemIcon.ShowWindow(SW_SHOW);
				m_iShowFileSystemIcon.EnableWindow(TRUE);		
				m_iShowLocalRating.ShowWindow(SW_SHOW);
				m_iShowLocalRating.EnableWindow(TRUE);		
				// [TPT] - MoNKi: -Support for High Contrast Mode-
				m_iHighContrast.ShowWindow(SW_SHOW);
				m_iHighContrast.EnableWindow(TRUE);		
				// [TPT] - Clear completed
				m_iClearCompleted.ShowWindow(SW_SHOW);
				m_iClearCompleted.EnableWindow(TRUE);		

				break;
			case MINIMULE:
				m_MiniMuleGroupBox.ShowWindow(SW_SHOW);
				m_MiniMuleGroupBox.EnableWindow(TRUE);					
				m_iMiniMule.ShowWindow(SW_SHOW);
				m_iMiniMule.EnableWindow(TRUE);	
				m_iMiniMuleLives.ShowWindow(SW_SHOW);
				m_iMiniMuleLives.EnableWindow(TRUE);	
				m_iMiniMuleUpdate.ShowWindow(SW_SHOW);
				m_iMiniMuleUpdate.EnableWindow(TRUE);	
				m_iMiniMuleUpdateStatic.ShowWindow(SW_SHOW);
				m_iMiniMuleUpdateStatic.EnableWindow(TRUE);
				m_MiniMuleTransparency.ShowWindow(SW_SHOW);
				m_MiniMuleTransparency.EnableWindow(TRUE);
				m_MiniMuleTransparencyStatic.ShowWindow(SW_SHOW);
				m_MiniMuleTransparencyStatic.EnableWindow(TRUE);
				m_MiniMuleTransparencyMinimum.ShowWindow(SW_SHOW);
				m_MiniMuleTransparencyMinimum.EnableWindow(TRUE);
				m_MiniMuleTransparencyMaximum.ShowWindow(SW_SHOW);
				m_MiniMuleTransparencyMaximum.EnableWindow(TRUE);
				break;

		}
	}
}

// [TPT] - quick start
void CPPgPhoenix::OnQuickStartChange(void)
{
	bool check = (m_iQuickStart.GetCheck() == BST_CHECKED);

	m_iMaxConn.EnableWindow(check);
	m_iMaxConnStatic.EnableWindow(check);				
	m_iMaxConnPerFive.EnableWindow(check);				
	m_iMaxConnPerFiveStatic.EnableWindow(check);

	SetModified(TRUE);
}
// [TPT] - quick start