//this file is part of eMule
//Copyright (C)2002 Merkur ( merkur-@users.sourceforge.net / http://www.emule-project.net )
//
//This program is free software; you can redistribute it and/or
//modify it under the terms of the GNU General Public License
//as published by the Free Software Foundation; either
//version 2 of the License, or (at your option) any later version.
//
//This program is distributed in the hope that it will be useful,
//but WITHOUT ANY WARRANTY; without even the implied warranty of
//MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
//GNU General Public License for more details.
//
//You should have received a copy of the GNU General Public License
//along with this program; if not, write to the Free Software
//Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.

#include "StdAfx.h"
#include "uploadqueue.h"
#include "packets.h"
#include "emule.h"
#include "SearchDlg.h"
#include "knownfile.h"
#include "listensocket.h"
#include "ini2.h"
#include "math.h"
#include "Exceptions.h"
#include "Scheduler.h"
#include "BandWidthControl.h" // [TPT]

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//TODO rewrite the whole networkcode, use overlapped sockets

// [TPT]

CUploadQueue::CUploadQueue(CPreferences* in_prefs){
	app_prefs = in_prefs;
	// [TPT]
	//VERIFY( (h_timer = SetTimer(0,0,100,UploadTimer)) );
	//if (!h_timer)
	//	AddDebugLogLine(true,_T("Failed to create 'upload queue' timer - %s"),GetErrorMessage(GetLastError()));
	//estadatarate = 2000;
	//datarate = 0;
	//dataratems = 0;
	//datarateave = 0;
	//counter=0;
	successfullupcount = 0;
	failedupcount = 0;
	totaluploadtime = 0;	
	//m_nUpDataRateMSOverhead = 0;
	//m_nUpDatarateOverhead = 0;
	m_nUpDataOverheadSourceExchange = 0;
	m_nUpDataOverheadFileRequest = 0;
	m_nUpDataOverheadOther = 0;
	m_nUpDataOverheadServer = 0;
	m_nUpDataOverheadSourceExchangePackets = 0;
	m_nUpDataOverheadFileRequestPackets = 0;
	m_nUpDataOverheadOtherPackets = 0;
	m_nUpDataOverheadServerPackets = 0;
	//m_nLastStartUpload = 0;
	//statsave=0;
	// -khaos--+++>
	//iupdateconnstats=0;
	// <-----khaos-
	// Maella -Pseudo overhead datarate control-
	m_nextAncTime = ::GetTickCount() + 5000;

	m_lastProcessTime = ::GetTickCount();
	m_lastSentBytes = 0;
	m_lastOverallSentBytes = 0;
    m_lastNetworkOut = 0;
	m_nUploadSlopeControl = 0;
	// Maella end
	// [TPT]-Cumulate Bandwidth
	priorityClient = NULL;
	// [TPT]-Cumulate Bandwidth END
}

void CUploadQueue::AddUpNextClient(CUpDownClient* directadd){
	POSITION toadd = 0;
	POSITION toaddlow = 0;
	uint32	bestscore = 0;
	uint32  bestlowscore = 0;
	CUpDownClient* newclient;
	// select next client or use given client
	if (!directadd){
		// [TPT]
		// Maella code Improvement
		for (POSITION pos = waitinglist.GetHeadPosition(); pos != NULL;){
			POSITION cur_pos = pos;
			CUpDownClient* cur_client =	waitinglist.GetNext(pos);
			// clear dead clients
			ASSERT ( cur_client->GetLastUpRequest() );
			if ((::GetTickCount() - cur_client->GetLastUpRequest() > MAX_PURGEQUEUETIME) || !theApp.sharedfiles->GetFileByID(cur_client->GetUploadFileID()) ){
				cur_client->ClearWaitStartTime();
				RemoveFromWaitingQueue(cur_pos,true);	
				if (!cur_client->socket)
					if(cur_client->Disconnected()){
						delete cur_client;
						cur_client = NULL;
					}
				continue;
			}
			//<<< eWombat [SNAFU][TPT] ignore banned clients
			if (cur_client->IsSnafu() || cur_client->IsNotSUI() || cur_client->IsBanned() )
				continue;
			//>>> eWombat [SNAFU][TPT]
			// finished clearing
			uint32 cur_score = cur_client->GetScore(true);
			if ( cur_score > bestscore){
				bestscore = cur_score;
				toadd = cur_pos;
			} else {
				cur_score = cur_client->GetScore(false);
				if ((cur_score > bestlowscore) && !cur_client->m_bAddNextConnect){
					bestlowscore = cur_score;
					toaddlow = cur_pos;
				}
			}
		}
		// Maella end
		
		if (bestlowscore > bestscore){
			newclient = waitinglist.GetAt(toaddlow);
			newclient->m_bAddNextConnect = true;
		}
		if (!toadd)
			return;
		newclient = waitinglist.GetAt(toadd);
		lastupslotHighID = true; // VQB LowID alternate
		//AddLogLine(true,"Added High ID: %s", newclient->GetUserName()); // VQB:  perhaps only add to debug log?
		RemoveFromWaitingQueue(toadd, true);
		theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
	}
	else {
		newclient = directadd;
		/*if (!IsDownloading(newclient)){
            if (newclient->HasLowID())
                AddLogLine(true,"DirectAdd:  LowID: %s", newclient->GetUserName());
			else
                AddLogLine(true,"DirectAdd:  HighID: %s", newclient->GetUserName());
		}*/
        //eWombat [SNAFU][TPT]si no se ha idenficado o snafu no aadimos
	if (directadd->IsSnafu() || directadd->IsNotSUI())
		return;

	}

	if (IsDownloading(newclient)){
		return;
	}
	// eWombat [SNAFU][TPT]
	//CHECK Snafus and suis
	if (newclient->IsSnafu() || newclient->IsNotSUI() || newclient->IsBanned())
	{
		newclient->ClearWaitStartTime(); //Xman modification
		return;
	}
	// eWombat [SNAFU][TPT]
	// tell the client that we are now ready to upload
	if (!newclient->socket || !newclient->socket->IsConnected()){
		newclient->SetUploadState(US_CONNECTING);
		if (!newclient->TryToConnect(true))
			return;
	}
	else{
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		newclient->socket->SendPacket(packet,true);
		newclient->SetUploadState(US_UPLOADING);
	}
	newclient->SetUpStartTime();
	newclient->ResetSessionUp();
	newclient->ResetProcessRate(); // [TPT]-Cumulate Bandwidth


	uploadinglist.AddTail(newclient);
	prioritylist.AddTail(newclient);// [TPT]-Cumulate Bandwidth
	
	// [TPT]
	// Maella -Pseudo overhead datarate control-
	// Let 20 seconds to the system to stabilize the upload datarate
	if(GetTickCount() - m_nextAncTime < 20000){
		m_nextAncTime = GetTickCount() + 20000;
	}
	// Maella end

	// statistic
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)newclient->GetUploadFileID());
	if (reqfile){
		reqfile->statistic.AddAccepted();
	}
		
	theApp.emuledlg->transferwnd.uploadlistctrl.AddClient(newclient);
}

// Maella -New bandwidth control-
void CUploadQueue::Process() {

	theApp.sharedfiles->Publish();
	// Only every 1 second
    static s_counter;
    if(s_counter++ >= (1000/TIMER_PERIOD)){
        s_counter = 0;

        // Maella -One-queue-per-file- (idea bloodymad)
        m_bIsReleaseSlotUsed = false;    
	    for(POSITION pos = uploadinglist.GetHeadPosition(); pos != NULL; ){
		    CUpDownClient* cur_client = uploadinglist.GetNext(pos);
            CKnownFile* curUpFile = theApp.sharedfiles->GetFileByID(cur_client->GetUploadFileID());
            if(curUpFile != NULL && curUpFile->GetUpPriority() == PR_VERYHIGH)
            {                
                m_bIsReleaseSlotUsed = true;
                break; // exit loop for()
            }
        }
        // Maella end

	    // Check if new client can be added to upload queue
        if(AcceptNewClient() && waitinglist.GetCount()){

		    // Trace some statistic for the debugging
		    if(theApp.glob_prefs->GetBlockMaellaSpecificMsg() == false){

                uint32 eMuleIn;	uint32 eMuleInOverall;
		        uint32 eMuleOut; uint32 eMuleOutOverall;
		        uint32 networkIn; uint32 networkOut;
		        theApp.pBandWidthControl->GetDatarates(5, // 5 seconds
										               eMuleIn, eMuleInOverall,
											           eMuleOut, eMuleOutOverall,
											           networkIn, networkOut);
                
                if(theApp.glob_prefs->GetNAFCEnable() == true && theApp.glob_prefs->GetNAFCFullControl() == true){
			        AddDebugLogLine(false, _T("Accept new client (%u+1), datarate avg./overall %u/%u [Bytes/s], adapter limit/avg. %u/%u [Bytes/s]"), 
											        uploadinglist.GetCount(),
											        eMuleOut,
											        eMuleOutOverall,
											        (uint32)(1024.0f * theApp.glob_prefs->GetNAFCNetworkOut()),
											        networkOut);
                }
                else {
			        AddDebugLogLine(false, _T("Accept new client (%u+1), datarate limit/avg./overall %u/%u/%u [Bytes/s], adapter threshold/avg. %u/%u [Bytes/s]"), 
											        uploadinglist.GetCount(),
                                                    (uint32)(1024.0f * theApp.glob_prefs->GetMaxUpload()),
											        eMuleOut,
											        eMuleOutOverall,
											        (uint32)(1024.0f * theApp.glob_prefs->GetNAFCNetworkOut()),
											        networkOut);
                }
	}

		AddUpNextClient();
	}
	}

	// Elapsed time (TIMER_PERIOD not accurate)	
	uint32 deltaTime = ::GetTickCount() - m_lastProcessTime;
	m_lastProcessTime += deltaTime;

    // Anticipate high CPU load => unregular cycle
    if(deltaTime > 0){
	    // Count number of client ready to send block
	    uint16 clientsrdy = 0;
		POSITION prev_pos = NULL;// [TPT]-Cumulate Bandwidth
		CUpDownClient* prev_client = NULL;// [TPT]-Cumulate Bandwidth
	    for(POSITION pos = uploadinglist.GetHeadPosition(); pos != NULL; ){
		    CUpDownClient* cur_client = uploadinglist.GetAt(pos);//[TPT]-Cumulate Bandwidth
		    //It seems chatting or friend slots can get stuck at times in upload.. This needs looked into..
			if (!cur_client->socket){
				pos = uploadinglist.GetHeadPosition();
				RemoveFromUploadQueue(cur_client, CUpDownClient::USR_NONE);
				if(cur_client->Disconnected()){
					delete cur_client;
				}
				clientsrdy = 0;
			} else 
			if(cur_client->socket->IsBusy() == false && 
				cur_client->HasBlocks() == true){
					++clientsrdy;
				}
				// [TPT]-Cumulate Bandwidth
			else {
				cur_client->m_uReadyTicks = 0;
				cur_client->m_uBusyTicks++;
				cur_client->CalcRatio(true);
			}
			if (theApp.glob_prefs->IsCumulateBandwidthEnabled() && prev_client && prev_client != priorityClient && prev_client->GetAvgRatio() < cur_client->GetAvgRatio()){
				uploadinglist.RemoveAt(pos);
				uploadinglist.InsertBefore(prev_pos, cur_client);
				pos = prev_pos;
			}
			else {
				prev_pos = pos;
				prev_client = cur_client;
			}
			uploadinglist.GetNext(pos);
			// [TPT]-Cumulate Bandwidth
		}
		
		if(clientsrdy == 0){
			m_nUploadSlopeControl = 0;

	        // Keep current value for next processing    
	        m_lastOverallSentBytes = theApp.pBandWidthControl->GeteMuleOutOverall();
	        m_lastSentBytes = theApp.pBandWidthControl->GeteMuleOut();    
            m_lastNetworkOut = theApp.pBandWidthControl->GetNetworkOut();
        }
        else {
	        float maxUpload;
	        if(theApp.glob_prefs->GetNAFCEnable() == true && theApp.glob_prefs->GetNAFCFullControl() == true){
                maxUpload = theApp.pBandWidthControl->GetMaxUpload();

                // Update the slope
                m_nUploadSlopeControl += (uint32)(maxUpload * 1.024f * (float)deltaTime); // [bytes/period]

                // Correct the slope with the nbre of byte sent during the last cycle
                m_nUploadSlopeControl -= (theApp.pBandWidthControl->GetNetworkOut() - m_lastNetworkOut);
	        }
            else if(app_prefs->GetCompensateOverhead() == true){
		        maxUpload = app_prefs->GetMaxUpload();

                // Update the slope
                m_nUploadSlopeControl += (uint32)(maxUpload * 1.024f * (float)deltaTime); // [bytes/period]

                // Correct the slope with the nbre of byte sent during the last cycle
                m_nUploadSlopeControl -= (uint32)(theApp.pBandWidthControl->GeteMuleOutOverall() - m_lastOverallSentBytes);
	        }
	        else {
		        maxUpload = app_prefs->GetMaxUpload();

                // Update the slope
                m_nUploadSlopeControl += (uint32)(maxUpload * 1.024f * (float)deltaTime); // [bytes/period]

                // Correct the slope with the nbre of byte sent during the last cycle
                m_nUploadSlopeControl -= (uint32)(theApp.pBandWidthControl->GeteMuleOut() - m_lastSentBytes);
	        }

	        // Compensate up to 1 second
	        if(m_nUploadSlopeControl > (sint32)(1024.0f * maxUpload)){
		        m_nUploadSlopeControl = (sint32)(1024.0f * maxUpload);
		        // But be sure to be able to send at least one packet
		        if(m_nUploadSlopeControl < 1500){				
			        m_nUploadSlopeControl = 1500;
		        }
			}

	        // Trunk negative value (up to 0.5 second) 
            // => possible when Overhead compensation activated
	        if(m_nUploadSlopeControl < (sint32)(-0.5 * 1024.0f * maxUpload)){
		        m_nUploadSlopeControl = (sint32)(-0.5 * 1024.0f * maxUpload);
	        }

            // Try to anticipate overhead
            const sint32 overhead = (sint32)(theApp.pBandWidthControl->GeteMuleOutOverall() - m_lastOverallSentBytes) - (sint32)(theApp.pBandWidthControl->GeteMuleOut() - m_lastSentBytes);

	        // Keep current value for next processing    
	        m_lastOverallSentBytes = theApp.pBandWidthControl->GeteMuleOutOverall();
	        m_lastSentBytes = theApp.pBandWidthControl->GeteMuleOut();    
            m_lastNetworkOut = theApp.pBandWidthControl->GetNetworkOut();

            // Anticipate overhead (80 %)
	        sint32 nUploadSlopeControl = m_nUploadSlopeControl;
            if((app_prefs->GetCompensateOverhead() == true) || (theApp.glob_prefs->GetNAFCEnable() == true && theApp.glob_prefs->GetNAFCFullControl() == true)){
                if(overhead > 0){
                    nUploadSlopeControl -= (overhead * deltaTime / 1000) * 8 / 10;
                }
            }

			// [TPT]-Cumulate Bandwidth
			if (theApp.glob_prefs->IsCumulateBandwidthEnabled()){
				//Serve trickle slots
				POSITION pos;
				for(pos = uploadinglist.GetHeadPosition(); pos != NULL; ){
					CUpDownClient* cur_client = uploadinglist.GetNext(pos);// Cumulate bandwidth
					if(cur_client->GetTimeSinceLastSent() > (uint32) 2*theApp.glob_prefs->GetMTU() && nUploadSlopeControl>6){
						uint32 sentBlock = cur_client->SendBlockData((uint32)nUploadSlopeControl);
						if(sentBlock > 0)
							nUploadSlopeControl -= sentBlock;
					}
				}
				//Find priority client
				if (!priorityClient && prioritylist.GetCount()){
					priorityClient=(CUpDownClient*) prioritylist.RemoveHead();
					if (pos = uploadinglist.Find(priorityClient)){
						uploadinglist.RemoveAt(pos);
						uploadinglist.AddHead(priorityClient);
					}
				}

				//Serve the bandwidth
				pos=uploadinglist.GetHeadPosition();
				while (pos && nUploadSlopeControl > 6){
					CUpDownClient* cur_client = uploadinglist.GetNext(pos);
					while (nUploadSlopeControl > 6){
							uint32 sentBlock = cur_client->SendBlockData((uint32)nUploadSlopeControl);		

							if(sentBlock > 0){
								cur_client->m_uReadyTicks++; // Cumulate Bandwidth
								cur_client->CalcRatio();
								nUploadSlopeControl -= sentBlock;
							}
							else
								break;
					}
				}
			}
			else {
				// [TPT]-Cumulate Bandwidth
				// Try to send blocks.
				bool multiSending;
				do
				{
					multiSending = false;
					POSITION next_pos = uploadinglist.GetHeadPosition();
					// Don't use an iterator => swap in loop
					for(int i=0; i<uploadinglist.GetCount() && nUploadSlopeControl>6 /*header size*/; i++){
						POSITION cur_pos = next_pos;
						CUpDownClient* cur_client = uploadinglist.GetNext(next_pos); // Already point to the next element

						// The method returns the real size of the sent block.
						// Remark: - it is not necessary to call every time this method
						//         - only one packet is sent every time this method is called
						uint32 sentBlock = cur_client->SendBlockData((uint32)nUploadSlopeControl);		

						if(sentBlock > 0){
							cur_client->m_uReadyTicks++; // [TPT]-Cumulate Bandwidth
							cur_client->CalcRatio(); // [TPT]-Cumulate Bandwidth
							nUploadSlopeControl -= sentBlock;

							// Try to 'balance' the upload between clients.
							// Move the 'sender' at the end of the list.
							uploadinglist.RemoveAt(cur_pos);
							uploadinglist.AddTail(cur_client);	

							// A client is allowed to send only one packet per call to SendBlockData() to insure
							// a better balancing between the clients. If a client was able to use its slot,
							// we will give him a second chance after having asked the others.
							multiSending = true;
						}
					}
				} while (multiSending == true && nUploadSlopeControl > 100);
			}
	}
	}
};
// Maella end

// Maella -Accurate measure of bandwidth: eDonkey data + control, network adapter-
void CUploadQueue::CompUploadRate(){	
	// Compute the upload datarate of all clients
	for(POSITION pos = uploadinglist.GetHeadPosition(); pos != NULL; ){
		uploadinglist.GetNext(pos)->CompUploadRate();
	}
}
// Maella end

// Maella -New bandwidth control-
bool CUploadQueue::AcceptNewClient(){

    if(theApp.glob_prefs->GetEnableNewUSS() == false){
        // Check hard lower/upper bounds
        if (uploadinglist.GetCount() < app_prefs->GetMinUploadSlot()){
            m_nextAncTime = GetTickCount() + 2000;
		return true;
        }
	else if (uploadinglist.GetCount() >= MAX_UP_CLIENTS_ALLOWED)
		return false;

	    // check if we can allow a new client to start downloading form us
	    if(GetTickCount() < m_nextAncTime)
            return false;

		// Time stamp for next evaluation
		m_nextAncTime = GetTickCount() + 2000;

		// Compute all datarates elapsed for the last 5 seconds
		uint32 eMuleIn;	uint32 eMuleInOverall;
		uint32 eMuleOut; uint32 eMuleOutOverall;
		uint32 networkIn; uint32 networkOut;
		theApp.pBandWidthControl->GetDatarates(5, // 5 seconds
										       eMuleIn, eMuleInOverall,
											   eMuleOut, eMuleOutOverall,
											   networkIn, networkOut);

	    uint32 upPerClient = UPLOAD_CLIENT_DATARATE + eMuleOut/50;
	    if( upPerClient > 10000 )
		upPerClient = 11000;

	//now the final check
	if (theApp.glob_prefs->GetMaxUpload() == UNLIMITED){
		    if ((uint32)uploadinglist.GetCount() < ((eMuleOut/upPerClient)+2))
			return true;
	}
	else{
		uint16 nMaxSlots = 0;
		if (theApp.glob_prefs->GetMaxUpload() > 10){
			nMaxSlots += 2;
			nMaxSlots += (uint16)ceil((float)((theApp.glob_prefs->GetMaxUpload() - 10)*1024) / upPerClient);
		}
		    else {
			    // Maella -Minimum Upload Slot-
			    nMaxSlots = app_prefs->GetMinUploadSlot();
			    // Maella end
		    }

		    if ((uint32)uploadinglist.GetCount() < (eMuleOut/UPLOAD_CHECK_CLIENT_DR) && uploadinglist.GetCount() <= nMaxSlots )
				return true;
			}
		}
    else {
        // Check hard lower/upper bounds
        if (uploadinglist.GetCount() < app_prefs->GetMinUploadSlot()){
            m_nextAncTime = GetTickCount() + 5000;
			return true;
		}
	    else if (uploadinglist.GetCount() >= MAX_UP_CLIENTS_ALLOWED) // 100
		    return false;

	    // Proceed evaluation only every n seconds
	    if(GetTickCount() >= m_nextAncTime) {

		    // Time stamp for next evaluation
		    m_nextAncTime = GetTickCount() + 5000;

		    // Compute all datarates elapsed for the last 5 seconds
		    uint32 eMuleIn;	uint32 eMuleInOverall;
		    uint32 eMuleOut; uint32 eMuleOutOverall;
		    uint32 networkIn; uint32 networkOut;
		    theApp.pBandWidthControl->GetDatarates(5, // 5 seconds
											       eMuleIn, eMuleInOverall,
											       eMuleOut, eMuleOutOverall,
											       networkIn, networkOut);

            // Calculate the max average upper limit per client
	        uint32 upPerClient = 4000 + eMuleOut/50;
            if(upPerClient > 10000){
		        upPerClient = 10000;
            }

            // Calculate max Slot
            uint16 nMaxSlots = app_prefs->GetMinUploadSlot(); // range 2..4
		    if(theApp.glob_prefs->GetNAFCEnable() == true && theApp.glob_prefs->GetNAFCFullControl() == true){
                const uint32 overHead = (networkOut > eMuleOut) ? (networkOut - eMuleOut) : 0;
                const uint32 availableOut = (uint32)(1024.0f * theApp.glob_prefs->GetNAFCNetworkOut()) - overHead;
                const uint32 dynMaxSlots = 2 + (availableOut + upPerClient - 1) / upPerClient;
                if(nMaxSlots < dynMaxSlots)
                    nMaxSlots = dynMaxSlots;
		    }
            else if(theApp.glob_prefs->GetCompensateOverhead() == true){
                const uint32 overHead = (eMuleOutOverall > eMuleOut) ? (eMuleOutOverall - eMuleOut) : 0;
                const uint32 availableOut = (uint32)(1024.0f * theApp.glob_prefs->GetMaxUpload()) - overHead;
                const uint32 dynMaxSlots = 2 + (availableOut + upPerClient - 1) / upPerClient;
                if(nMaxSlots < dynMaxSlots)
                    nMaxSlots = dynMaxSlots;
		    }
		    else {
                const uint32 availableOut = (uint32)(1024.0f * theApp.glob_prefs->GetMaxUpload());
                // e.g. MaxUpload = 25 [KB/s]
                //  no upload   => upPerClient = 4000 + 0*1024/50 = 4000
                //                 nMaxSlot = 2 + (25*1024 + 4000 - 1) / 4000 = 2 + 7.39 = 9
                //
                //  full upload => upPerClient = 4000 + 25*1024/50 = 4512
                //                 nMaxSlot = 2 + (25*1024 + 4512 - 1) / 4512 = 2 + 6.67 = 8
                //
                // e.g. MaxUpload = 12.47 [KB/s]
                //  full upload => upPerClient = 4000 + 12.47*1024/50 = 4255
                //                 nMaxSlot = 2 + (12.47*1024 + 4255 - 1) / 4255 = 2 + 4.00 = 6
                //
                // e.g. MaxUpload = 8.14 [KB/s]
                //  full upload => upPerClient = 4000 + 8.14*1024/50 = 4166
                //                 nMaxSlot = 2 + (8.14*1024 + 4166 - 1) / 4166 = 2 + 3.00 = 5
                //
                // e.g. MaxUpload = 3.99 [KB/s]
                //  full upload => upPerClient = 4000 + 3.99*1024/50 = 4082
                //                 nMaxSlot = 2 + (3.99*1024 + 4082 - 1) / 4082 = 2 + 2.00 = 4
                //
                const uint32 dynMaxSlots = 2 + (availableOut + upPerClient - 1) / upPerClient;
                if(nMaxSlots < dynMaxSlots)
                    nMaxSlots = dynMaxSlots;
		    }

            if(uploadinglist.GetCount() < nMaxSlots){

                // Check if the upload is unbalanced between the clients
                for(POSITION pos = uploadinglist.GetHeadPosition(); pos != NULL; ){
                    if(uploadinglist.GetNext(pos)->GetUploadDatarate(5) > 2 * upPerClient)
                        return true;
                }

                // Check the NAFC condition
                // => Detect network load caused by other applications
                if(theApp.glob_prefs->GetNAFCEnable() == true){
                    if(networkOut > (uint32)(1024.0f * theApp.glob_prefs->GetNAFCNetworkOut()))
                        return false;
                }

                // Check datarate
		        if(theApp.glob_prefs->GetNAFCEnable() == true && theApp.glob_prefs->GetNAFCFullControl() == true){
                    if(networkOut < (uint32)(0.90f * 1024.0f * theApp.glob_prefs->GetNAFCNetworkOut()) || // up to 90%
                       networkOut + 1000 < (uint32)(1024.0f * theApp.glob_prefs->GetNAFCNetworkOut())) 
                        return true;
                }
                else if(theApp.glob_prefs->GetCompensateOverhead() == true){
                    if(eMuleOutOverall < (uint32)(0.90f * 1024.0f * theApp.glob_prefs->GetMaxUpload()) || // up to 90%
                       eMuleOutOverall + 1000 < (uint32)(1024.0f * theApp.glob_prefs->GetMaxUpload())) 
                        return true;
                }
		        else {
                    if(eMuleOut < (uint32)(0.90f * 1024.0f * theApp.glob_prefs->GetMaxUpload()) || // up to 90%
                       eMuleOut + 1000 < (uint32)(1024.0f * theApp.glob_prefs->GetMaxUpload())) 
			return true;
	}
	}
	    }
    }

	return false;
}
// Maella end

CUploadQueue::~CUploadQueue(){
	// [TPT]
}

CUpDownClient* CUploadQueue::GetWaitingClientByIP_UDP(uint32 dwIP, uint16 nUDPPort){
	// [TPT]
	for (POSITION pos = waitinglist.GetHeadPosition(); pos != 0;){
		CUpDownClient* cur_client = waitinglist.GetNext(pos);
		if (dwIP == cur_client->GetIP() && nUDPPort == cur_client->GetUDPPort())
			return cur_client;
	}
	return 0;
}


/*void CUploadQueue::UpdateBanCount(){
	int count=0;
	for (POSITION pos = waitinglist.GetHeadPosition();pos != 0;waitinglist.GetNext(pos)){
		CUpDownClient* cur_client= waitinglist.GetAt(pos);
		if(cur_client->IsBanned())
			count++;
	}
	SetBanCount(count);
}*/

void CUploadQueue::AddClientToQueue(CUpDownClient* client, bool bIgnoreTimelimit){
	if (theApp.serverconnect->IsConnected() && theApp.serverconnect->IsLowID() //This may need to be changed with the Kad now being used.
		&& !theApp.serverconnect->IsLocalServer(client->GetServerIP(),client->GetServerPort())
		&& client->GetDownloadState() == DS_NONE && !client->IsFriend()
		&& GetWaitingUserCount() > 50)
		return;
	if (client->IsNotSUI())
		theApp.clientlist->AddSnafuClient(client);//eWombat [SNAFU][TPT]

	client->AddAskedCount();
	client->SetLastUpRequest();
	if (!bIgnoreTimelimit){
		client->AddRequestCount(client->GetUploadFileID());
	}
	if ( client->IsBanned() )
		return;
	uint16 cSameIP = 0;
	// check for double
	// [TPT] Patch. Code Improvement	
	for (POSITION pos = waitinglist.GetHeadPosition(); pos != NULL;){
		POSITION cur_pos = pos;		
		CUpDownClient* cur_client= waitinglist.GetNext(pos);
		if (cur_client == client){	//already on queue
// VQB LowID Slot Patch -- note:  should add limit so only if #slots < UL -or- UL+1 for Low UL (?)
			if (client->m_bAddNextConnect && (uploadinglist.GetCount() < theApp.glob_prefs->GetMaxUpload())){
				if (lastupslotHighID) {
					client->m_bAddNextConnect = false;
					RemoveFromWaitingQueue(client, true);
					AddUpNextClient(client);
					lastupslotHighID = false; // LowID alternate
					return;
				}
			}
// VQB end
			client->SendRankingInfo();
			theApp.emuledlg->transferwnd.queuelistctrl.RefreshClient(client);
			return;			
		}
		else if ( client->Compare(cur_client) ) {
			theApp.clientlist->AddTrackClient(client); // in any case keep track of this client

			// another client with same ip:port or hash
			// this happens only in rare cases, because same userhash / ip:ports are assigned to the right client on connecting in most cases
			if (cur_client->credits != NULL && cur_client->credits->GetCurrentIdentState(cur_client->GetIP()) == IS_IDENTIFIED){
				//cur_client has a valid secure hash, don't remove him
				AddDebugLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),client->GetUserName() );
				return;
			}
			if (client->credits != NULL && client->credits->GetCurrentIdentState(client->GetIP()) == IS_IDENTIFIED){
				//client has a valid secure hash, add him remove other one
				AddDebugLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),cur_client->GetUserName() );
				RemoveFromWaitingQueue(cur_pos,true);	
				if (!cur_client->socket){
					if(cur_client->Disconnected()){
						delete cur_client;
					}
				}
			}
			else
				{
				// eWombat [SNAFU][TPT]	
				if (theApp.glob_prefs->GetAntiCreditTheft())
					{
					//cur_client has higher Trust, dont remove him
					if (cur_client->GetTrust() > client->GetTrust())
						{
						client->DoSnafu(SNAFU_ACT);
						return;
						}
					if (client->GetTrust() > cur_client->GetTrust())
						{
						cur_client->DoSnafu(SNAFU_ACT);
						RemoveFromWaitingQueue(cur_pos,true);	
				if (!cur_client->socket){
					if(cur_client->Disconnected()){
						delete cur_client;
					}
				}
						}
					else
						{
				// remove both since we dont know who the bad on is
						client->DoSnafu(SNAFU_ACT);
						cur_client->DoSnafu(SNAFU_ACT);
				RemoveFromWaitingQueue(cur_pos,true);	
				if (!cur_client->socket){
					if(cur_client->Disconnected()){
						delete cur_client;
					}
				}
				return;
			}
		}
				else
					{
				// remove both since we dont know who the bad on is
				AddDebugLogLine(false,CString(GetResString(IDS_SAMEUSERHASH)),client->GetUserName(),cur_client->GetUserName(),"Both" );
				RemoveFromWaitingQueue(cur_pos,true);	
				if (!cur_client->socket){
					if(cur_client->Disconnected()){
						delete cur_client;
					}
			}
				return;
			}
		}
			}
		// eWombat [SNAFU][TPT]
		else if (client->GetIP() == cur_client->GetIP()){
			// same IP, different port, different userhash
			cSameIP++;
		}
	}
	if (cSameIP >= 3){
		// do not accept more than 3 clients from the same IP
		DEBUG_ONLY(AddDebugLogLine(false,"%s's (%s) request to enter the queue was rejected, because of too many clients with the same IP",client->GetUserName(), client->GetFullIP() ));
		return;
	}
	else if (theApp.clientlist->GetClientsFromIP(client->GetIP()) >= 3){
		DEBUG_ONLY(AddDebugLogLine(false,"%s's (%s) request to enter the queue was rejected, because of too many clients with the same IP (found in TrackedClientsList)",client->GetUserName(), client->GetFullIP() ));
		return;
	}
	// done

	// Add clients server to list.
	if (theApp.glob_prefs->AddServersFromClient() && client->GetServerIP() && client->GetServerPort()){
		in_addr host;
		host.S_un.S_addr = client->GetServerIP();
		CServer* srv = new CServer(client->GetServerPort(), inet_ntoa(host));
		srv->SetListName(srv->GetAddress());

		if (!theApp.emuledlg->serverwnd.serverlistctrl.AddServer(srv, true))
			delete srv;
	}

	// statistic values
	CKnownFile* reqfile = theApp.sharedfiles->GetFileByID((uchar*)client->GetUploadFileID());
	if (reqfile)
		reqfile->statistic.AddRequest();
	// TODO find better ways to cap the list
	if (!theApp.glob_prefs->IsInfiniteQueueEnabled() && ((uint32)waitinglist.GetCount() > theApp.glob_prefs->GetQueueSize()))	// [TPT] - SLUGFILLER: infiniteQueue
		return;
	if (client->IsDownloading()){
		// he's already downloading and wants probably only another file
		Packet* packet = new Packet(OP_ACCEPTUPLOADREQ,0);
		theApp.uploadqueue->AddUpDataOverheadFileRequest(packet->size);
		client->socket->SendPacket(packet,true);
		return;
	}
	if (waitinglist.IsEmpty() && AcceptNewClient()){
		AddUpNextClient(client);
		//m_nLastStartUpload = ::GetTickCount();
	}
	else{
		waitinglist.AddTail(client);
		client->SetUploadState(US_ONUPLOADQUEUE);
		theApp.emuledlg->transferwnd.queuelistctrl.AddClient(client,true);
		theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
		client->SendRankingInfo();
	}
}
// [TPT]
// Maella -Code Improvement-
bool CUploadQueue::RemoveFromUploadQueue(CUpDownClient* client, CUpDownClient::UpStopReason reason, bool updatewindow){ // Maella -Upload Stop Reason-
	theApp.clientlist->AddTrackClient(client); // Keep track of this client
	POSITION pos = uploadinglist.Find(client);
	if(pos != NULL){
		// [TPT]-Cumulate Bandwidth
		if (client == priorityClient)
			priorityClient=NULL;
		// [TPT]-Cumulate Bandwidth end
        // Remove client
		if(updatewindow)
			theApp.emuledlg->transferwnd.uploadlistctrl.RemoveClient(client);
			uploadinglist.RemoveAt(pos);
		// [TPT]-Cumulate Bandwidth
		if (pos=prioritylist.Find(client))
			prioritylist.RemoveAt(pos);
		// [TPT]-Cumulate Bandwidth end

			// Maella -Failed Upload Session Count-
			if(client->GetSessionUp() > 0){
				++successfullupcount;
				totaluploadtime += client->GetUpStartTimeDelay()/1000;				
				CUpDownClient::AddUpStopCount(false, reason);
			}
			else {
				++failedupcount;
				CUpDownClient::AddUpStopCount(true, reason);
			}
			// Maella end

			client->SetUploadState(US_NONE);
			client->ClearUploadBlockRequests();
//			CKnownFile* reqfile = theApp.sharedfiles->GetFileByID(client->GetUploadFileID());
//			if( reqfile )
//				reqfile->SubQueuedCount();
//			client->SetUploadFileID(NULL);
			return true;
		}
	return false;
}

uint32 CUploadQueue::GetAverageUpTime(){
	if( successfullupcount ){
		return totaluploadtime/successfullupcount;
	}
	return 0;
}

bool CUploadQueue::RemoveFromWaitingQueue(CUpDownClient* client, bool updatewindow){
	POSITION pos = waitinglist.Find(client);
	if (pos){
		RemoveFromWaitingQueue(pos,updatewindow);
		if (updatewindow)
			theApp.emuledlg->transferwnd.ShowQueueCount(waitinglist.GetCount());
		return true;
	}
	else
		return false;
}

void CUploadQueue::RemoveFromWaitingQueue(POSITION pos, bool updatewindow){	
	CUpDownClient* todelete = waitinglist.GetAt(pos);
	waitinglist.RemoveAt(pos);
	if (updatewindow)
		theApp.emuledlg->transferwnd.queuelistctrl.RemoveClient(todelete);
	todelete->SetUploadState(US_NONE);
}


bool CUploadQueue::CheckForTimeOver(CUpDownClient* client){
	if( client->GetUpStartTimeDelay() > 3600000 ){ // Try to keep the clients from downloading for ever.
		AddDebugLogLine(false, "%s: Upload session ended due to excessive time.", client->GetUserName());
		return true;
	}


	if (!theApp.glob_prefs->TransferFullChunks()){

		// Cache current client score
		const uint32 score = client->GetScore(true, true);

		// Check if another client has a bigger score
		for(POSITION pos = waitinglist.GetHeadPosition(); pos != 0; )
			if(score < waitinglist.GetNext(pos)->GetScore(true, false)){
				//AddDebugLogLine(false, "%s: Upload session ended due to score.", client->GetUserName());
				return true;
			}
	}
	else{
	// more than one chunk allowed if we use the score system

	// For some reason, some clients can continue to download after a chunk size.
	// Are they redownloading the same chunk over and over????
	if( client->GetSessionUp() > 10485760 ){
		AddDebugLogLine(false, "%s: Upload session ended due to excessive transfered amount.", client->GetUserName());
		return true;
	}

	}
	return false;
}

void CUploadQueue::DeleteAll(){
	waitinglist.RemoveAll();
	uploadinglist.RemoveAll();
}

// [TPT]
// Maella -One-queue-per-file- (idea bloodymad)
uint16 CUploadQueue::GetWaitingPosition(CUpDownClient* client){
	if (!IsOnUploadQueue(client))
		return 0;

	uint16 rank = 1;
	const uint32 myscore = client->GetScore(false);

	if(theApp.glob_prefs->GetEnableMultiQueue() == false){
		for(POSITION pos = waitinglist.GetHeadPosition(); pos != NULL; ){
			if(waitinglist.GetNext(pos)->GetScore(false) > myscore)
				rank++;
				}
			}
	else {
		// Compare score only with others clients waiting for the same file
		for(POSITION pos = waitinglist.GetHeadPosition(); pos != NULL; ){
			CUpDownClient* pOtherClient = waitinglist.GetNext(pos);
			if(md4cmp(client->GetUploadFileID(), pOtherClient->GetUploadFileID()) == 0 && 
			   pOtherClient->GetScore(false) > myscore){
				rank++;
			}
		}
	}
	return rank;
}
// Maella end

CUpDownClient* CUploadQueue::GetNextClient(CUpDownClient* lastclient){
	if (waitinglist.IsEmpty())
		return 0;
	if (!lastclient)
		return waitinglist.GetHead();
	POSITION pos = waitinglist.Find(lastclient);
	if (!pos){
		TRACE("Error: CServerList::GetNextClient");
		return waitinglist.GetHead();
	}
	waitinglist.GetNext(pos);
	if (!pos)
		return NULL;
	else
		return waitinglist.GetAt(pos);
}

void CUploadQueue::FindSourcesForFileById(CTypedPtrList<CPtrList, CUpDownClient*>* srclist, const uchar* filehash) {
	POSITION pos;
	
	pos = uploadinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = uploadinglist.GetNext(pos);
		if(md4cmp(potential->GetUploadFileID(), filehash) == 0)
			srclist->AddTail(potential);
	}

	pos = waitinglist.GetHeadPosition();
	while(pos) {
		CUpDownClient *potential = waitinglist.GetNext(pos);
		if(md4cmp(potential->GetUploadFileID(), filehash) == 0)
			srclist->AddTail(potential);
	}
}
